"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactPortal = require("react-portal");

var _styledComponents = require("styled-components");

var _Slide = _interopRequireDefault(require("@material-ui/core/Slide"));

var _elements = require("../elements");

var _globalCss = _interopRequireDefault(require("../styles/global-css"));

var _styles = _interopRequireDefault(require("../styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var getTransition = function getTransition(show, position) {
  var transition = _Slide.default;
  var transitionProps = {
    in: show,
    direction: 'up',
    mountOnEnter: true,
    unmountOnExit: true
  };

  if (position === 'flex-start') {
    transitionProps.direction = 'down';
  }

  if (position !== 'flex-start' && position !== 'flex-end') {
    transition = 'span';
    transitionProps = {};
  }

  return {
    transition: transition,
    transitionProps: transitionProps
  };
};

var updateCoords = {
  startBottomLeft: function startBottomLeft(coords) {
    return {
      top: "".concat(coords.bottom + window.pageYOffset, "px"),
      left: "".concat(coords.left + window.pageXOffset, "px")
    };
  },
  startBottomRight: function startBottomRight(coords) {
    return {
      top: "".concat(coords.bottom + window.pageYOffset, "px"),
      right: "".concat(window.innerWidth - coords.right + window.pageXOffset, "px")
    };
  },
  startTopLeft: function startTopLeft(coords) {
    return {
      top: "".concat(coords.top + window.pageYOffset - 300, "px"),
      left: "".concat(coords.left + window.pageXOffset, "px")
    };
  },
  startTopRight: function startTopRight(coords) {
    return {
      top: "".concat(coords.top + window.pageYOffset - 300, "px"),
      right: "".concat(window.innerWidth - coords.right + window.pageXOffset, "px")
    };
  }
};

var NumPad = function NumPad(_ref) {
  var children = _ref.children,
      placeholder = _ref.placeholder,
      label = _ref.label,
      theme = _ref.theme,
      locale = _ref.locale,
      markers = _ref.markers,
      position = _ref.position,
      sync = _ref.sync,
      customInput = _ref.customInput,
      onChange = _ref.onChange,
      valueFromProps = _ref.value,
      formatInputValue = _ref.formatInputValue,
      displayRule = _ref.displayRule;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var _useState3 = (0, _react.useState)(formatInputValue(valueFromProps)),
      _useState4 = _slicedToArray(_useState3, 2),
      value = _useState4[0],
      setValue = _useState4[1];

  var _useState5 = (0, _react.useState)(),
      _useState6 = _slicedToArray(_useState5, 2),
      preValue = _useState6[0],
      setPreValue = _useState6[1];

  var _useState7 = (0, _react.useState)(),
      _useState8 = _slicedToArray(_useState7, 2),
      inputCoords = _useState8[0],
      setInputCoords = _useState8[1];

  if (valueFromProps !== preValue) {
    setPreValue(valueFromProps);
    setValue(formatInputValue(valueFromProps));
  }

  var toggleKeyPad = (0, _react.useCallback)(function () {
    var coords = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    setInputCoords(!show && updateCoords[position] ? updateCoords[position](coords) : undefined);
    setShow(!show);
  }, [show, position]);
  var confirm = (0, _react.useCallback)(function (value) {
    if (show) {
      onChange(displayRule(value));
      setValue(value);
    }

    setShow(!show);
  }, [value, show]); // Update internal state, if sync is true call the external onChange callback on each change

  var update = (0, _react.useCallback)(function (value) {
    setValue(value);

    if (sync) {
      onChange(displayRule(value));
    }
  }, [value]);
  var customTheme = _typeof(theme) === 'object' ? theme : (0, _styles.default)(theme);
  customTheme.position = position;
  customTheme.coords = inputCoords;
  var display = position !== 'flex-start' && position !== 'flex-end' ? show : true;

  var _getTransition = getTransition(show, position),
      transition = _getTransition.transition,
      transitionProps = _getTransition.transitionProps;

  return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_globalCss.default, null), _react.default.createElement(_styledComponents.ThemeProvider, {
    theme: customTheme
  }, _react.default.createElement(_elements.InputField, {
    placeholder: placeholder,
    showKeyPad: toggleKeyPad,
    inputValue: valueFromProps.toString(),
    label: label,
    disabled: show,
    customInput: customInput
  })), _react.default.createElement(_reactPortal.Portal, null, display && _react.default.createElement(transition, transitionProps, _react.default.createElement(_styledComponents.ThemeProvider, {
    theme: customTheme
  }, _react.default.createElement(_elements.Wrapper, {
    show: true
  }, _react.default.cloneElement(children, {
    cancel: toggleKeyPad,
    confirm: confirm,
    update: update,
    value: value,
    label: label,
    locale: locale,
    markers: markers,
    sync: sync
  }))))));
};

NumPad.defaultProps = {
  children: undefined,
  customInput: undefined,
  placeholder: undefined,
  position: 'flex-end',
  formatInputValue: function formatInputValue(value) {
    return value.toString();
  },
  label: undefined,
  theme: undefined,
  locale: 'en',
  value: '',
  sync: false,
  markers: []
};
NumPad.propTypes = {
  onChange: _propTypes.default.func.isRequired,
  children: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.arrayOf(_propTypes.default.element)]),
  customInput: _propTypes.default.oneOfType([_propTypes.default.element, _propTypes.default.arrayOf(_propTypes.default.element)]),
  placeholder: _propTypes.default.string,
  position: _propTypes.default.string,
  label: _propTypes.default.string,
  locale: _propTypes.default.string,
  formatInputValue: _propTypes.default.func,
  theme: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  value: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  sync: _propTypes.default.bool
};
var _default = NumPad;
exports.default = _default;