"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/* eslint-disable jsx-a11y/label-has-associated-control */

/* eslint-disable jsx-a11y/label-has-for */
var InputField = function InputField(_ref) {
  var showKeyPad = _ref.showKeyPad,
      placeholder = _ref.placeholder,
      inputValue = _ref.inputValue,
      label = _ref.label,
      disabled = _ref.disabled,
      customInput = _ref.customInput;
  var input = (0, _react.useRef)(null);
  var inputWrapper = (0, _react.useRef)(null);

  var onShowKeyPad = function onShowKeyPad() {
    if (input.current) {
      input.current.blur();
    }

    var inputCoords = inputWrapper.current ? inputWrapper.current.getBoundingClientRect() : undefined;
    showKeyPad(inputCoords);
  };

  return _react.default.createElement(_react.default.Fragment, null, label && _react.default.createElement("label", {
    disabled: disabled
  }, label), _react.default.createElement("span", {
    onClick: onShowKeyPad,
    onKeyPress: onShowKeyPad,
    role: "button",
    tabIndex: 0,
    ref: inputWrapper
  }, customInput ? _react.default.Children.map(customInput, function (child) {
    return (// TODO: implement an input finder inside the children dom. Now it finds only at the first level deep.
      _react.default.cloneElement(child, child.type === 'input' ? {
        placeholder: placeholder,
        value: inputValue,
        disabled: disabled,
        tabIndex: -1,
        readOnly: true,
        ref: function ref(input) {
          input = input;
        }
      } : {})
    );
  }) : _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("input", {
    style: {
      outline: 'none'
    },
    ref: input,
    placeholder: placeholder,
    value: inputValue,
    disabled: disabled,
    tabIndex: -1,
    readOnly: true
  }))));
};

InputField.displayName = 'InputField';
InputField.defaultProps = {
  placeholder: '',
  inputValue: '',
  label: '',
  disabled: false,
  customInput: undefined
};
InputField.propTypes = {
  showKeyPad: _propTypes.default.func.isRequired,
  inputValue: _propTypes.default.string,
  placeholder: _propTypes.default.string,
  label: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  customInput: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.arrayOf(_propTypes.default.element)])
};
var _default = InputField;
exports.default = _default;