"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _md = require("react-icons/md");

var _KeypadButton = _interopRequireDefault(require("./KeypadButton"));

var _Display = _interopRequireDefault(require("./Display"));

var _mediaTemplates = require("../styles/media-templates");

var _ui = _interopRequireDefault(require("./ui"));

var _useKeyboardInput = _interopRequireDefault(require("../hooks/useKeyboardInput"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  flex-wrap: wrap;\n  flex-grow: 1;\n  button {\n    border-bottom: 1px solid #ddd;\n    border-right: 1px solid #ddd;\n  }\n  button:nth-child(3n) {\n    border-right: none;\n  }\n  button:nth-child(-n + 3) {\n    border-top: 1px solid #ddd;\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: space-between;\n  padding: 2px 4px;\n  align-items: center;\n  color: ", ";\n  background: ", ";\n  user-select: none;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  overflow: hidden;\n  font-size: 1.3em;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["width: 100%;"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  flex-direction: column;\n  width: 264px;\n  ", " height: 300px;\n  background: ", ";\n  transition: all 450ms cubic-bezier(0.23, 1, 0.32, 1) 0ms;\n  box-shadow: rgba(0, 0, 0, 0.25) 0px 14px 45px, rgba(0, 0, 0, 0.22) 0px 10px 18px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Content = _styledComponents.default.div(_templateObject(), _mediaTemplates.media.mobile(_templateObject2()), function (props) {
  return props.theme.body.backgroundColor;
});

var Label = _styledComponents.default.div(_templateObject3());

var Header = _styledComponents.default.div(_templateObject4(), function (props) {
  return props.theme.header.secondaryColor;
}, function (props) {
  return props.theme.header.backgroundColor;
});

var Keys = _styledComponents.default.div(_templateObject5());

var KeyPad = function KeyPad(_ref) {
  var displayRule = _ref.displayRule,
      validation = _ref.validation,
      label = _ref.label,
      confirm = _ref.confirm,
      cancel = _ref.cancel,
      keyValid = _ref.keyValid,
      value = _ref.value,
      update = _ref.update,
      sync = _ref.sync;
  // @ts-ignore
  var keypadKeys = ['7', '8', '9', '4', '5', '6', '1', '2', '3', '-', '0', '.'];

  var keyboardKeys = _toConsumableArray(Array(10).keys()).map(function (v) {
    return v.toString();
  });

  var _useState = (0, _react.useState)(value),
      _useState2 = _slicedToArray(_useState, 2),
      inputValue = _useState2[0],
      setInputValue = _useState2[1];

  var keyboard = (0, _useKeyboardInput.default)(inputValue, keyboardKeys.filter(function (key) {
    return keyValid(inputValue, key);
  })); // Reload props.value into the state

  (0, _react.useEffect)(function () {
    setInputValue(value);
  }, [value]);

  function computeNextKey(newValue, key) {
    var computedValue = inputValue;

    if (key === '-') {
      computedValue = inputValue.charAt(0) === '-' ? inputValue.substr(1) : "-".concat(newValue);
    } else if (key === '.' && keyValid(inputValue, key)) {
      computedValue = (newValue === '' ? '0' : newValue) + key;
    } else if (keyValid(newValue.slice(0, -1), key)) {
      computedValue = newValue;
    }

    setInputValue(computedValue);

    if (sync) {
      update(computedValue);
    }
  }

  (0, _react.useEffect)(function () {
    if (keyboard.keyDownEvent) {
      if (['Enter', 'Tab'].includes(keyboard.keyDownEvent.key) && validation(keyboard.value)) {
        confirm(keyboard.value);
      } else if (['Escape'].includes(keyboard.keyDownEvent.key)) {
        cancel();
      } else if (['Backspace'].includes(keyboard.keyDownEvent.key)) {
        if (keyboard.keyDownEvent.ctrlKey || keyboard.keyDownEvent.altKey) {
          setInputValue('');
        } else {
          setInputValue(keyboard.value);
        }
      } else {
        computeNextKey(keyboard.value, keyboard.keyDownEvent.key);
      }
    }
  }, [keyboard.value, keyboard.keyDownEvent]);
  return _react.default.createElement(Content, null, _react.default.createElement(Header, null, _react.default.createElement(_ui.default, null, _react.default.createElement(_md.MdCancel, {
    onClick: cancel
  })), _react.default.createElement(Label, null, label), _react.default.createElement(_ui.default, {
    onClick: function onClick() {
      return confirm(inputValue);
    },
    disabled: !validation(inputValue)
  }, validation(inputValue) ? _react.default.createElement(_md.MdCheckCircle, null) : _react.default.createElement(_md.MdCheck, null))), _react.default.createElement(_Display.default, {
    value: displayRule(inputValue),
    backspace: function backspace() {
      return keyboard.virtualInteraction('Backspace');
    },
    longPressBackspace: function longPressBackspace() {
      return setInputValue('');
    }
  }), _react.default.createElement(Keys, null, keypadKeys.map(function (key) {
    return _react.default.createElement(_KeypadButton.default, {
      key: "button-".concat(key),
      click: function click(clickedKey) {
        return keyboard.virtualInteraction(clickedKey.toString());
      },
      value: key,
      disabled: !keyValid(inputValue, key)
    });
  })));
};

KeyPad.displayName = 'KeyPad';
KeyPad.propTypes = {
  label: _propTypes.default.string,
  confirm: _propTypes.default.func.isRequired,
  cancel: _propTypes.default.func.isRequired,
  displayRule: _propTypes.default.func.isRequired,
  validation: _propTypes.default.func.isRequired,
  keyValid: _propTypes.default.func.isRequired,
  value: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  sync: _propTypes.default.bool,
  update: _propTypes.default.func.isRequired
};
KeyPad.defaultProps = {
  label: undefined,
  value: '',
  sync: false
};

var _default = (0, _reactOnclickoutside.default)(KeyPad, {
  handleClickOutside: function handleClickOutside(instance) {
    return function (evt) {
      evt.preventDefault();
      evt.stopPropagation();
      var _instance$props = instance.props,
          value = _instance$props.value,
          validation = _instance$props.validation,
          confirm = _instance$props.confirm,
          cancel = _instance$props.cancel;

      if (validation(value)) {
        confirm(value);
      } else {
        cancel();
      }
    };
  }
});

exports.default = _default;