"use strict";

var _date = require("../date");

test('padding', function () {
  expect((0, _date.padding)('02102012', 'DD.MM.YYYY')).toBe('02102012');
  expect((0, _date.padding)('021020', 'DD.MM.YYYY')).toBe('02102020');
  expect((0, _date.padding)('0210201201', 'DD.MM.YYYY HH:mm')).toBe('021020120102');
  expect((0, _date.padding)('', 'DD.MM.YYYY HH:mm:ss')).toBe('01032020010203');
  expect((0, _date.padding)('1', 'DD.MM.YYYY HH:mm:ss')).toBe('11032020010203');
});
test('validate', function () {
  expect((0, _date.validate)((0, _date.padding)('2902', 'DD.MM.YYYY'), 'DD.MM.YYYY', 3)).toBe(true);
  expect((0, _date.validate)((0, _date.padding)('311', 'DD.MM.YYYY'), 'DD.MM.YYYY', 2)).toBe(true);
  expect((0, _date.validate)((0, _date.padding)('3101', 'DD.MM.YYYY'), 'DD.MM.YYYY', 3)).toBe(true);
  expect((0, _date.validate)((0, _date.padding)('311', 'DD.MM.YYYY'), 'DD.MM.YYYY', 2)).toBe(true);
  expect((0, _date.validate)((0, _date.padding)('290', 'DD.MM.YYYY'), 'DD.MM.YYYY', 2)).toBe(true);
});
test('validate time', function () {
  expect((0, _date.validate)('3', 'HH:mm')).toBe(false);
});